/* 
 *   $Id: ad_ufs_open.c,v 1.5 2000/02/09 21:30:01 thakur Exp $    
 *
 *   Copyright (C) 1997 University of Chicago. 
 *   See COPYRIGHT notice in top-level directory.
 */

#include "ad_ntfs.h"

void ADIOI_NTFS_Open(ADIO_File fd, int *error_code)
{
    int cmode, amode;
#ifndef PRINT_ERR_MSG
    static char myname[] = "ADIOI_NTFS_OPEN";
#endif

    amode = 0;
	cmode = 0;
    if (fd->access_mode & ADIO_CREATE)
	cmode = OPEN_ALWAYS; //CREATE_ALWAYS;
    if (fd->access_mode & ADIO_EXCL)
	cmode = CREATE_NEW;

    if (fd->access_mode & ADIO_RDONLY)
	amode = amode | FILE_SHARE_READ;
    if (fd->access_mode & ADIO_WRONLY)
	amode = amode | FILE_SHARE_WRITE;
    if (fd->access_mode & ADIO_RDWR)
	amode = amode | FILE_SHARE_READ | FILE_SHARE_WRITE;

	fd->fd_sys = CreateFile(
		fd->filename, 
		GENERIC_READ | GENERIC_WRITE, // | STANDARD_RIGHTS_ALL,
		amode, 
		NULL, 
		cmode, 
		FILE_ATTRIBUTE_NORMAL, 
		//FILE_FLAG_OVERLAPPED | FILE_FLAG_RANDOM_ACCESS, 
		NULL);

    if ((fd->fd_sys != INVALID_HANDLE_VALUE) && (fd->access_mode & ADIO_APPEND))
		fd->fp_ind = fd->fp_sys_posn = SetFilePointer(fd->fd_sys, 0, NULL, FILE_END);

#ifdef PRINT_ERR_MSG
    *error_code = (fd->fd_sys == INVALID_HANDLE_VALUE) ? MPI_ERR_UNKNOWN : MPI_SUCCESS;
#else
    if (fd->fd_sys == INVALID_HANDLE_VALUE) {
	*error_code = MPIR_Err_setmsg(MPI_ERR_IO, MPIR_ADIO_ERROR,
			      myname, "I/O Error", "%s", strerror(errno));
	ADIOI_Error(ADIO_FILE_NULL, *error_code, myname);	    
    }
    else *error_code = MPI_SUCCESS;
#endif
}
